#
# langfreq.R, 14 Feb 20

library("corrgram")
library("plyr")


p_and_fit=function(df)
{
re=count(DM[, df])

if (nrow(re) < 10)
   return()

col_str=lang_col$col_str[which(lang_col$langs == df)]

points(re, col=col_str)

max_x=min(re$x[which(re$freq == 1)])
x_range=1:max_x

re_mod=glm(log(freq) ~ log(x), data=re, subset=x_range)
summary(re_mod)
print(df)
print(coef(re_mod))

pred=predict(re_mod)
lines(x_range, exp(pred[x_range]), col=col_str)

}


DM=read.csv("dm.csv.xz", as.is=TRUE)

langs=c("StackOverflowRegexSource",
	# "RegExLibRegexSource", # 250 regexs of which 211 are unique
	"cpan",
	# "crates.io", # 2,511 regexs of which 2,025 are unique
	"godoc","maven","npm",
	"packagist","pypi","rubygems")

lang_col=data.frame(langs, col_str=rainbow(length(langs)),
					stringsAsFactors=FALSE)

# re_cnt=count(DM$cpan)

plot(0.1, type="n", log="xy",
	xlim=c(1, 100), ylim=c(1, 1e5),
	xlab="Occurrences", ylab="Patterns")

legend(x="topright", legend=langs, bty="n", fill=lang_col$col_str, cex=1.3)

dum=sapply(langs, p_and_fit)

# re_mod=glm(log(freq) ~ log(x), data=re_cnt, subset=1:100)
# summary(re_mod)

# cor requires numeric columns
regex_dups = subset(DM, select=langs)

# Cross correlation ellipses
ctab = cor(regex_dups, method = "spearman", use="complete.obs")

used = subset(homebrew_req, select=columns)

# Cross correlation ellipses
ctab = cor(used, method = "spearman", use="complete.obs")
, cex.cor=0.9)

corrgram(ctab, cex=1, cex.cor=1.3,
		upper.panel=panel.pie, lower.panel=panel.cor)

dev.copy(device=png, file="/usr1/rbook/pat-occur.png")
dev.copy(device=png, file="/usr1/rbook/lang-cor.png")
dev.off()

